CON

DATABUSSTARTPIN = 0
RXPIN = 8
TXPIN = 9

MYCLKVAL     = 1<<TXPIN
MYDIRAVAL    = ($ff<<DATABUSSTARTPIN) | (1<<TXPIN)
MYDATADIRVAL = ($ff<<DATABUSSTARTPIN)
MYPINOKVAL   = 1<<RXPIN
MYDATASHIFT = DATABUSSTARTPIN

PROPGFX_NTSC                    = 0 ' use this to set region mode for NTSC        
PROPGFX_PAL                     = 1 ' use this to set region mode to PAL

'ResetLite options
PROPGFX_RESET_TV                = 0 ' this one resets the TV + Tile + 3D drivers, and doesn't reset the Comms driver 
PROPGFX_RESET_FULL              = 1 ' this is like a cold reset, it does a full reboot.

'Triangle offsets ( in words )
PROPGFX_POLYC                   = 0
PROPGFX_POLYX1                  = 1
PROPGFX_POLYY1                  = 2
PROPGFX_POLYX2                  = 3
PROPGFX_POLYY2                  = 4
PROPGFX_POLYX3                  = 5
PROPGFX_POLYY3                  = 6
PROPGFX_POLYLN                  = 7

'Plot offsets ( in words )
PROPGFX_PLOTC                   = 1
PROPGFX_PLOTX                   = 2
PROPGFX_PLOTY                   = 3

'Circle offsets ( in words )
PROPGFX_CIRCLEC                 = 1
PROPGFX_CIRCLEX                 = 2
PROPGFX_CIRCLEY                 = 3
PROPGFX_CIRCLER                 = 4

'Line offsets ( in words )
PROPGFX_LINEC                   = 1
PROPGFX_LINEFROMX               = 2
PROPGFX_LINEFROMY               = 3
PROPGFX_LINETOX                 = 4
PROPGFX_LINETOY                 = 5

PROPGFX_0_3D_COGS               = 6 ' this is to set the amount of scanline renderers, ( 6 = 0 left for POLY cogs )
PROPGFX_1_3D_COG                = 5 ' this is to set the amount of scanline renderers, ( 5 = 1 left for POLY cogs )
PROPGFX_1_3D_COGS               = 5 ' this is to set the amount of scanline renderers, ( 5 = 1 left for POLY cogs ) added this one incase people leave the trailing S
PROPGFX_2_3D_COGS               = 4 ' this is to set the amount of scanline renderers, ( 4 = 2 left for POLY cogs )
PROPGFX_4_3D_COGS               = 2 ' this is to set the amount of scanline renderers, ( 2 = 4 left for POLY cogs )

PROPGFX_0_SCROLL_COGS           = 6
PROPGFX_1_SCROLL_COG            = 5
PROPGFX_1_SCROLL_COGS           = 5

PROPGFX_MODE_XSCROLLERS_ENABLE  = 8

PROPGFX_FILLED_MODE             = 0
PROPGFX_WIREFRAME_MODE          = 1

PROPGFX_NORMAL_SPRITES          = 0
PROPGFX_C64_SPRITES             = 1                        

PROPGFX_POLY_STOP               = 511 ' this is a stop command for the POLY renderer to STOP processing and go back to waiting for starter instruction.
PROPGFX_POLY_SET_BASE           = 510 ' this will read the next WORD and use that as the new screen base for the POLY renderer.
PROPGFX_POLY_CLS                = 509 ' cls this will clear the screen with 0
PROPGFX_POLY_SET_WINDOW         = 508 ' 
PROPGFX_POLY_SET_8_PATS         = 507
PROPGFX_POLY_CLR_WINDOW         = 506 
PROPGFX_POLY_PLOT               = 505         
PROPGFX_POLY_CIRCLE             = 504
PROPGFX_POLY_LINE               = 503

PROPGFX_SCROLL_STOP             = 511
PROPGFX_SCROLL_SET_SCR_BASE     = 510
PROPGFX_SCROLL_SET_BLK_BASE     = 509
PROPGFX_SCROLL_SET_MAP_BASE     = 508
PROPGFX_SCROLL_CLS              = 507
PROPGFX_SCROLL_SET_MAP_XY       = 506
PROPGFX_SCROLL_SET_MAP_SIZE     = 505
PROPGFX_SCROLL_SET_WIN_XYWH     = 504
PROPGFX_SCROLL_CLR_WIN          = 503
PROPGFX_SCROLL_UPDATE_MAP       = 502
PROPGFX_SCROLL_SCROLL_UP        = 501
PROPGFX_SCROLL_SCROLL_UR        = 500
PROPGFX_SCROLL_SCROLL_RT        = 499
PROPGFX_SCROLL_SCROLL_DR        = 498
PROPGFX_SCROLL_SCROLL_DN        = 497
PROPGFX_SCROLL_SCROLL_DL        = 496
PROPGFX_SCROLL_SCROLL_LT        = 495
PROPGFX_SCROLL_SCROLL_UL        = 494
PROPGFX_SCROLL_UPDATE_TP        = 493
PROPGFX_SCROLL_UPDATE_BT        = 492
PROPGFX_SCROLL_UPDATE_LT        = 491
PROPGFX_SCROLL_UPDATE_RT        = 490

PROPGFX_SCROLL_BLOCK_1x1        = 0
PROPGFX_SCROLL_BLOCK_2x2        = 1
PROPGFX_SCROLL_BLOCK_4x4        = 2
PROPGFX_SCROLL_BLOCK_8x8        = 3

PROPGFX_SET_SPLIT_MODE          = $80         

PROPGFX_2BIT_CHAR_MODE          = 1                        
PROPGFX_4BIT_CHAR_MODE          = 2
PROPGFX_8BIT_BIG_BITMAP_MODE    = 3                        
PROPGFX_1BIT_BITMAP_MODE        = 4                        
PROPGFX_2BIT_BITMAP_MODE        = 5                        
PROPGFX_4BIT_BITMAP_MODE        = 6                        
PROPGFX_8BIT_BITMAP_MODE        = 7

PROPGFX_SPECCY_MODE             = 0
PROPGFX_SPECCY_HICOLOUR         = 1
PROPGFX_SPECCY_CHARMAP          = 2                        

PROPGFX_SPRITE_OFF_SCREEN       = $01f0

PROPGFX_PIXEL_BUFF_BASE         = $00d4 ' where the scanlines are generated
PROPGFX_PIXEL_BUFF_END2         = $039c ' end of the second scanline render cog's buffer. ( can't display using one cog it's not really fast enough. )
PROPGFX_PIXEL_BUFF_END3         = $04fc ' end of the third scanline render cog's buffer. 
PROPGFX_PIXEL_BUFF_END4         = $065c ' end of the fourth scanline render cogs' buffer.
PROPGFX_PIXEL_BUFF_END5         = $07bc ' end of the fifth scanline render cogs' buffer.
PROPGFX_PIXEL_BUFF_END6         = $091c ' end of the sixth scanline render cogs' buffer.                                                  

PROPGFX_POLY_BUFF_BASE_BIG      = $680
PROPGFX_POLY_BUFF_BASE          = $1000
PROPGFX_SPRITE_LIST_BASE        = $13c0
PROPGFX_CHRPAL_BASE             = $1600
PROPGFX_SPRPAL_BASE             = $1700
PROPGFX_CHRMAP_BASE             = $1800
PROPGFX_CHRSET_BASE             = $2000
PROPGFX_SPECCY_ATTR_BASE        = $2000+$1800
PROPGFX_BITMAP_BASE             = $2000
PROPGFX_SPRSET_BASE             = $5000
PROPGFX_SPRSET_BASE2            = $4000 'use for more sprite base when not in bitmap mode
PROPGFX_SPRSET_BASE_AMS         = $6000

PROPGFX_COGNUM                  = $18
PROPGFX_STATUS                  = $1c
PROPGFX_ENABLE                  = $20
PROPGFX_TVPINS                  = $24
PROPGFX_TVMODE                  = $28
PROPGFX_XTILES                  = $2c
PROPGFX_YTILES                  = $30
PROPGFX_SCALEX                  = $34
PROPGFX_SCALEY                  = $38
PROPGFX_OFFSETX                 = $3c
PROPGFX_OFFSETY                 = $40
PROPGFX_BROADCAST               = $44
PROPGFX_AURALCOG                = $48
PROPGFX_LINEBUF                 = $4c
PROPGFX_BORDERPTR               = $50
PROPGFX_DOSPLITMODE             = $52                        
PROPGFX_SPLITY                  = $53                        
PROPGFX_NEXTLNPTR               = $54 
PROPGFX_SPLIT_XSCR              = $56                        
PROPGFX_SPLIT_YSCR              = $57                        
PROPGFX_MODE                    = $58
PROPGFX_BITMAPPTR               = $5a
PROPGFX_VSYNCVAL                = $5c
PROPGFX_CHRMAPPTR               = $60
PROPGFX_CHRMAPPTR_SPLIT         = $62
PROPGFX_CHRSETPTR               = $64
PROPGFX_CHRSETPTR_SPLIT         = $66
PROPGFX_CHRPALPTR               = $68
PROPGFX_CHRPALPTR_SPLIT         = $6a
PROPGFX_COGCOUNT                = $6c
PROPGFX_XSCROLLER               = $70
PROPGFX_YSCROLLER               = $71
PROPGFX_SPRITECOUNT             = $90
PROPGFX_SPRITECOUNT_SPLIT       = $92
PROPGFX_SPRITECTRL              = $93
PROPGFX_SPRLSTPTR               = $94 
PROPGFX_SPRLSTPTR_SPLIT         = $96 
PROPGFX_SPRPALPTR               = $98 
PROPGFX_SPRPALPTR_SPLIT         = $9a 
PROPGFX_SPRCHRPTR               = $9c 
PROPGFX_SPRCHRPTR_SPLIT         = $9e 
PROPGFX_NEXTLINE                = $a0
PROPGFX_BORDERCOL               = $a4
PROPGFX_BITMAPPTR_SPLIT         = $a6
PROPGFX_3DLISTPTR               = $a8
PROPGFX_3DSTAT1                 = $ac
PROPGFX_3DSTAT2                 = $b0
PROPGFX_DRIVEROFFSET            = $b4
PROPGFX_ID                      = $b8
PROPGFX_COMMSCOGPTR             = $bc
PROPGFX_TVCOGPTR                = $c0
PROPGFX_TILECOGPTR              = $c4
PROPGFX_3DCOGPTR                = $c8

PROPGFX_MAIN_VGA_CODE           = $801a
PROPGFX_MAIN_TV_CODE            = $801c
PROPGFX_PARALLAX_TV_CODE        = $801e

PROPGFX_PARALLAX_SPACETILE      = 32

PROPGFX_MAIN_TILE_CODE          = $8020
PROPGFX_SPECCY_TILE_CODE        = $8022

PROPGFX_MAIN_SPR64_TILE_CODE    = $8028
PROPGFX_SPECCY_SPR64_TILE_CODE  = $802a

PROPGFX_1BIT_3D_CODE            = $8030
PROPGFX_2BIT_3D_CODE            = $8032
PROPGFX_4BIT_3D_CODE            = $8034
PROPGFX_8BIT_3D_CODE            = $8036

PROPGFX_1BIT_LINE_CODE          = $8038
PROPGFX_2BIT_LINE_CODE          = $803a
PROPGFX_4BIT_LINE_CODE          = $803c
PROPGFX_8BIT_LINE_CODE          = $803e

PROPGFX_SCROLLER_COG_CODE       = $8040

PROPGFX_STOP_COG_CODE           = $8042

PROPGFX_PARALLAX_GRAPHICS_CODE  = $8044
PROPGFX_STOP_COG_DEAD_CODE      = $8046




SPRX = 0
SPRY = 1
SPRP = 2
SPRC = 3

var

  long  sendcog    ' used to store the coms COGID on, so I can start and stop it to swap to the opposite com mode, without using too cogs. 
  
  long  sendsrc    ' send source address ( sending props Hub-RAM address of buffer to send from )
  long  senddst    ' send destination address ( Lite Hub-RAM Address of buffer to send to )
  long  sendlen    ' send buffer length
  long  databack   ' data back from PropGFX

  byte  fontbuf[32] ' 32byte buffer for expanding a 1bit font into a 4bit font.

  long  myid       'Long to say what it's connected to, "L"ite or "V"GA in low byte "GFXL" version number

  word  txtx,txty

con
PROPGFX_CMD_UP = 0<<16
PROPGFX_CMD_VS = 1<<16
PROPGFX_CMD_DB = 2<<16
PROPGFX_CMD_IO = 3<<16
PROPGFX_CMD_CG = 4<<16
PROPGFX_CMD_ID = 5<<16
PROPGFX_CMD_ER = 6<<16
PROPGFX_CMD_EW = 7<<16
PROPGFX_CMD_DN = 8<<16
PROPGFX_CMD_RS = 9<<16
PROPGFX_CMD_PL = 10<<16
PROPGFX_CMD_FW = 11<<16
PROPGFX_CMD_MW = 12<<16
PROPGFX_CMD_MAX = 13 'number after last instruction. 

PUB PropGFX_Start  ' Initialise Comms PINS
  if sendcog
    cogstop(sendcog - 1)
    sendcog~

  sendlen:=0                    ' Clear Send Length so it doesn't send automatically if sendlen had a value in, as this variable triggers start send in databus mode
  
  sendcog:=cognew(@SendBytes,@sendsrc)+1 ' start DataBus Comms

  repeat 1000                   ' give it chance to start before returning ;)

PUB PropGFX_TestValid : val | i
  myid~
  val~
  dira:=mydira
  if (ina&mypinok)==0
    outa:=myclk | MYDATADIRVAL
    outa:=MYDATADIRVAL 
    outa:=myclk | MYDATADIRVAL 
    repeat 15000
      if (ina&mypinok)==mypinok
        outa~
        GetID
        val:=1
      outa~
    
PUB PropGFX_SendChar(ptr,i)     ' send one 32byte buffer (ptr) to a specific character (i)
  SendBuf(ptr,PROPGFX_CHRSET_BASE+(i<<5),32)

PUB PropGFX_PrintChar(c,x,y)    ' send a character (C) to position on character screen (X,Y)
  SendBuf(@c,PROPGFX_CHRMAP_BASE+(((y<<5)+x)<<1),2)

PUB PrintAt(x,y,c) | t          ' print string (pointed to in C) to position on character screen (X,Y)
  repeat while byte[c][0]       ' repeat until 0 byte ie, end of string
    PropGFX_PrintChar(byte[c][0],x,y) ' printchar in c at x,y
    c++                         ' point C to next character in string                        
    x++                         ' move cursor X position note, I've not put end of line wrap round. nor have I put any fancy ANSI style function characters either.                        

PUB PropGFX_SendFont(ptr,targ)|c,x,y,t ' send a 1bit font (ptr) to GFXLite HUB-RAM address targ
  repeat c from 32 to 127       ' copies to characters 32 to 127
    repeat y from 0 to 7        ' 8 pixels high
      t:=byte[ptr][((c-32)<<3)+y] ' character 32 is taken from ptr, not ptr + (32*8) as this removes the first 32 ascii control characters
      repeat x from 0 to 3      ' 4 bytes, as the target image is 4bit so 4 bytes = 8 pixels
        fontbuf[y<<2+x]:=$00    ' set initial value to 0
        if t & $80              ' if left pixel is set
          fontbuf[y<<2+x]+=$01  ' change initial value to have colour 1
        if t & $40              ' if right pixel is set                        
          fontbuf[y<<2+x]+=$10  ' change initial value to have colour 1 << 4     remembering on Lite, pixels are reversed. 
        t:=t<<2                 ' rotate pixels left 2 pixels and repeat  
    SendBuf(@fontbuf,targ+(c<<5),32) ' send these 32 bytes in font buf to targ+(c*32) 
  PropGFX_SendFontPal           ' send palette too.

PUB PropGFX_SendFontPal | c     ' send palette
  repeat c from 0 to 15         ' send 16 palettes of two colours
    SendBuf(@fontpal+c*2,PROPGFX_CHRPAL_BASE+(c<<4),2) ' send the bytes
   
PUB WaitVSync                   ' wait for VBlank
  sendlen:=PROPGFX_CMD_VS                ' special control length in sendlen as it only has 32KB of ram, it will never viably have a length to send > 32K
  repeat while sendlen<>0       ' wait until they've been sent, this is DataBus mode only, as Serial doesn't handshake.

PUB SendBuf(src,dst,len) | tte  ' Send Buf to Lite
  sendsrc:=src                ' set sendsrc to source address ( src )
  senddst:=dst                ' set senddst to destination address ( dst )
  sendlen:=len                ' set sendlen to length of buffer ( len )
  repeat while sendlen<>0     ' wait til it's all sent
  
PUB GetID : idval            ' Set ComMode to (mode)
  sendlen:=PROPGFX_CMD_ID          ' Set sendlen to Code $fc000000 + mode which tells databus coms to send "J","B","I","D",mode
  repeat while sendlen<>0     ' Wait for all bytes to be sent
  idval:=databack
  myid:=idval  

PUB RequestID : idval
  idval := myid & 255
   
PUB RequestIDVersion : idval
  idval := myid
   
PUB Debug(onoff)                ' Set Debug LED on Lite on or off  
  sendlen:=PROPGFX_CMD_DB+onoff        ' set sendlen to command $e0000000 + onoff ( which databus comms reads and sends "J","B","D","B",onoff
  repeat while sendlen<>0     ' wait til it's all sent 
   
PUB WaitSendBuf(src,dst,len) | tte ' Wait til previous buffer Sent then start new send, without waiting for finish
  repeat while sendlen<>0     ' wait til it's idle
  sendsrc:=src                ' set sendsrc to source address ( src )
  senddst:=dst                ' set senddst to destination address ( dst )
  sendlen:=len                ' set sendlen to length of buffer ( len )

PUB WaitIdle                    ' wait til DataBus Comms is idle
  repeat while sendlen<>0       ' wait til it's idle

PUB CogStart(cogpar,cogaddr,cogidx)
  repeat while sendlen<>0
  sendsrc:=((cogpar>>2)<<18)+((cogaddr>>2)<<4)+cogidx
  sendlen:=PROPGFX_CMD_CG
  repeat while sendlen<>0
  repeat 1000

PUB SendPropPal(src,dst,len) | ppi
 SendBuf(src,dst,len)

PUB SetPropPal(ptr) | i
  repeat i from 2 to 255
    PokeByte(ptr+i,i)
  PokeWord(ptr,$0202)

PUB R_W_EEPROM(rdwr,src,dst,len)
  sendsrc:=src                ' set sendsrc to source address ( src )
  senddst:=dst                ' set senddst to destination address ( dst )
  if rdwr==0
    sendlen:=PROPGFX_CMD_ER+len    ' set sendlen to source Length ( len )
  else
    sendlen:=PROPGFX_CMD_EW+len    ' set sendlen to source Length ( len )
  repeat while sendlen<>0     ' wait til it's idle

PUB GetBuf(src,dst,len) | tte   ' Get Buf from Lite
  sendsrc:=src                ' set sendsrc to source address ( src )
  senddst:=dst                ' set senddst to destination address ( dst )
  sendlen:=PROPGFX_CMD_DN+len      ' set sendlen to length of buffer ( len )
  repeat while sendlen<>0     ' wait til it's all sent
  
PUB ResetLite(softhard)
'  WaitVSync
  PokeByte(PROPGFX_ENABLE,0)
  sendlen:=PROPGFX_CMD_RS+softhard ' set sendlen to JBRS command
  repeat while sendlen<>0     ' wait til it's all sent
  if(softhard==1)
    cogstop(sendcog-1)            ' Then Stop DataBus cog
    sendcog~
    repeat 4
      waitcnt (clkfreq + cnt)
    PropGFX_Start
    PropGFX_TestValid
  PokeByte(PROPGFX_ENABLE,1)
  
PUB DoScroller
  DoPolys
  
PUB DoPolys
  sendlen:=PROPGFX_CMD_PL          ' set sendlen to JBPL command
  repeat while sendlen<>0     ' wait til it's all sent
  
PUB FillWords(src,val,len)
  sendsrc:=src                ' set sendsrc to source address ( src )
  senddst:=val                ' set senddst to fill value
  sendlen:=PROPGFX_CMD_FW+len      ' set sendlen to JBFW command
  repeat while sendlen<>0     ' wait til it's all sent

PUB MoveWords(src,dst,len)
  sendsrc:=src                ' set sendsrc to source address ( src )
  senddst:=dst                ' set senddst to destination address ( dst )
  sendlen:=PROPGFX_CMD_MW+len      ' set sendlen to JBMW command
  repeat while sendlen<>0     ' wait til it's all sent

PUB PokeByte(addr,val)
  SendBuf(@val,addr,1)
  
PUB PokeWord(addr,val)
  SendBuf(@val,addr,2)
  
PUB PokeLong(addr,val)
  SendBuf(@val,addr,4)

PUB PeekByte(addr) : val
  GetBuf(addr,@val,1)
  return val
  
PUB PeekWord(addr) : val
  GetBuf(addr,@val,2)
  return val

PUB PeekLong(addr) : val
  GetBuf(addr,@val,4)
  return val

PUB SetPolyWindow(polybase,x,y,w,h)
  PokeWord(polybase,PROPGFX_POLY_SET_WINDOW)
  PokeWord(polybase+2,x)
  PokeWord(polybase+4,y)
  PokeWord(polybase+6,w)
  PokeWord(polybase+8,h)
  PokeWord(polybase+10,PROPGFX_POLY_STOP)
  DoPolys

PUB SetPolyScrBase(polybase,base)
  PokeWord(polybase,PROPGFX_POLY_SET_BASE)
  PokeWord(polybase+2,base)
  PokeWord(polybase+4,PROPGFX_POLY_STOP)
  DoPolys

pub TVTextPrint(x,y,c)
  repeat while byte[c][0]
    TVTextPrt(byte[c][0],x,y)
    x++
    c++

PUB TVTextPrt(c,x,y)
  PokeWord($1800+((y   * 32 + x)*2), (c & 1) << 10 + $200 + c & $FE )
  PokeWord($1800+((y+1 * 32 + x)*2), (c & 1) << 10 + $200 + c & $FE +1 )

PUB SetSpeccyMode(pal,mode,num3dcogs,filledornot,C64OrNormalSprites) | i
  WaitVSync
  PokeByte(PROPGFX_ENABLE,0)
  PokeWord(PROPGFX_XSCROLLER,0)
  PokeLong(PROPGFX_XTILES,32)
  PokeLong(PROPGFX_YTILES,24)
  PokeByte(PROPGFX_TVMODE,pal)
  PokeWord(PROPGFX_DOSPLITMODE,0)
  PokeByte(PROPGFX_SPLIT_XSCR,0)
  PokeByte(PROPGFX_SPLIT_YSCR,0)
  PokeWord(PROPGFX_MODE,mode)
  PokeLong(PROPGFX_SCALEX,10+((pal&1)<<1))
  PokeLong(PROPGFX_COGCOUNT,num3dcogs)
  PokeLong(PROPGFX_SPRLSTPTR,$13c013c0)
  PokeLong(PROPGFX_SPRCHRPTR,$50005000)
  PokeLong(PROPGFX_SPRPALPTR,$17001700)
  PokeLong(PROPGFX_CHRPALPTR,$16001600)
  PokeLong(PROPGFX_CHRMAPPTR,$38003800)
  PokeLong(PROPGFX_CHRSETPTR,$20002000)
  PokeWord(PROPGFX_BITMAPPTR,$2000)
  PokeWord(PROPGFX_BITMAPPTR_SPLIT,$2000)
  PokeLong(PROPGFX_SPRITECOUNT,$00460046)
  PokeWord(PROPGFX_3DLISTPTR,PROPGFX_POLY_BUFF_BASE)
  FillWords(PROPGFX_SPRITE_LIST_BASE,PROPGFX_SPRITE_OFF_SCREEN,70*4)
  R_W_EEPROM(0,PROPGFX_MAIN_TV_CODE,PROPGFX_TVCOGPTR,2)
  if(C64OrNormalSprites)
    R_W_EEPROM(0,PROPGFX_SPECCY_SPR64_TILE_CODE,PROPGFX_TILECOGPTR,2)
  else
    R_W_EEPROM(0,PROPGFX_SPECCY_TILE_CODE,PROPGFX_TILECOGPTR,2)
  R_W_EEPROM(0,PROPGFX_1BIT_3D_CODE+((filledornot&1)*8),PROPGFX_3DCOGPTR,2)
  if(mode&3==PROPGFX_SPECCY_CHARMAP)
    R_W_EEPROM(0,PROPGFX_SCROLLER_COG_CODE,PROPGFX_3DCOGPTR,2)
    PokeLong(PROPGFX_CHRMAPPTR,$18001800)
  ResetLite(0)
  FillWords($2000,0,$1800/2)
  FillWords($3800,$3838,$300/2)
  if(mode&3==PROPGFX_SPECCY_HICOLOUR)
    FillWords($3800,$3838,$1800/2)

PUB SetBasicMode(pal,mode,num3dcogs,filledornot,C64OrNormalSprites) | i
  WaitVSync
  PokeByte(PROPGFX_ENABLE,0)
  PokeWord(PROPGFX_XSCROLLER,0)
  PokeLong(PROPGFX_XTILES,32)
  PokeLong(PROPGFX_YTILES,24)
  PokeByte(PROPGFX_TVMODE,pal)
  PokeWord(PROPGFX_MODE,mode)
  PokeWord(PROPGFX_DOSPLITMODE,0)
  PokeByte(PROPGFX_SPLIT_XSCR,0)
  PokeByte(PROPGFX_SPLIT_YSCR,0)
  PokeLong(PROPGFX_SCALEX,10+((pal&1)<<1))
  PokeLong(PROPGFX_COGCOUNT,num3dcogs)
  PokeLong(PROPGFX_SPRLSTPTR,$13c013c0)
  PokeLong(PROPGFX_SPRCHRPTR,$50005000)
  PokeLong(PROPGFX_SPRPALPTR,$17001700)
  PokeLong(PROPGFX_CHRPALPTR,$16001600)
  PokeLong(PROPGFX_CHRMAPPTR,$18001800)
  PokeLong(PROPGFX_CHRSETPTR,$20002000)
  PokeWord(PROPGFX_BITMAPPTR,$2000)
  PokeLong(PROPGFX_SPRITECOUNT,$000460046)
  PokeWord(PROPGFX_3DLISTPTR,PROPGFX_POLY_BUFF_BASE)
  FillWords(PROPGFX_SPRITE_LIST_BASE,PROPGFX_SPRITE_OFF_SCREEN,70*4)
  R_W_EEPROM(0,PROPGFX_MAIN_TV_CODE,PROPGFX_TVCOGPTR,2)
  if(C64OrNormalSprites)
    R_W_EEPROM(0,PROPGFX_MAIN_SPR64_TILE_CODE,PROPGFX_TILECOGPTR,2)
  else
    R_W_EEPROM(0,PROPGFX_MAIN_TILE_CODE,PROPGFX_TILECOGPTR,2)
  if((mode&7==PROPGFX_2BIT_CHAR_MODE) or (mode&7==PROPGFX_4BIT_CHAR_MODE))
    R_W_EEPROM(0,PROPGFX_SCROLLER_COG_CODE,PROPGFX_3DCOGPTR,2)
  if(mode&7==PROPGFX_1BIT_BITMAP_MODE)
    R_W_EEPROM(0,PROPGFX_1BIT_3D_CODE+((filledornot&1)*8),PROPGFX_3DCOGPTR,2)
  if(mode&7==PROPGFX_2BIT_BITMAP_MODE)
    R_W_EEPROM(0,PROPGFX_2BIT_3D_CODE+((filledornot&1)*8),PROPGFX_3DCOGPTR,2)
  if(mode&7==PROPGFX_4BIT_BITMAP_MODE)
    R_W_EEPROM(0,PROPGFX_4BIT_3D_CODE+((filledornot&1)*8),PROPGFX_3DCOGPTR,2)
  if(mode&7==PROPGFX_8BIT_BITMAP_MODE)
    R_W_EEPROM(0,PROPGFX_8BIT_3D_CODE+((filledornot&1)*8),PROPGFX_3DCOGPTR,2)
    PokeWord(PROPGFX_MODE,mode | 16)
  if(mode&7==PROPGFX_8BIT_BIG_BITMAP_MODE)
    R_W_EEPROM(0,PROPGFX_8BIT_3D_CODE+((filledornot&1)*8),PROPGFX_3DCOGPTR,2)
    PokeLong(PROPGFX_CHRSETPTR,$08000800)
    PokeWord(PROPGFX_BITMAPPTR,$0800)
    PokeWord(PROPGFX_BITMAPPTR_SPLIT,$0800)
    PokeWord(PROPGFX_3DLISTPTR,PROPGFX_POLY_BUFF_BASE_BIG)
  if(mode&7>2)
    FillWords($2000,0,$3000/2)
  ResetLite(0)
  if(mode&7==PROPGFX_8BIT_BIG_BITMAP_MODE)
    PokeLong(PROPGFX_SPRITECOUNT,$00000000)
    FillWords($800,0,$7800/2)
    PokeLong(PROPGFX_CHRPALPTR,$07000700)
    SetPolyScrBase(PROPGFX_POLY_BUFF_BASE_BIG,$800)

PUB SetParallaxMode(xt,yt,pal,hx) | i
  WaitVSync
'  PokeByte(PROPGFX_ENABLE,0)
  PokeWord(PROPGFX_XSCROLLER,0)
  PokeLong(PROPGFX_XTILES,xt)
  PokeLong(PROPGFX_YTILES,yt)
  PokeByte(PROPGFX_TVMODE,pal)
  PokeWord(PROPGFX_MODE,0)
  PokeWord(PROPGFX_DOSPLITMODE,0)
  PokeByte(PROPGFX_SPLIT_XSCR,0)
  PokeByte(PROPGFX_SPLIT_YSCR,0)
  PokeLong(PROPGFX_SCALEX,hx)
  PokeLong(PROPGFX_COGCOUNT,PROPGFX_0_3D_COGS)
  PokeLong(PROPGFX_SPRCHRPTR,$5000)
  PokeLong(PROPGFX_SPRPALPTR,$1700)
  PokeLong(PROPGFX_CHRPALPTR,$1600)
  PokeLong(PROPGFX_CHRMAPPTR,$1800)
  PokeLong(PROPGFX_CHRSETPTR,$2000)
  PokeWord(PROPGFX_BITMAPPTR,$2000)
  PokeWord(PROPGFX_3DLISTPTR,$200)
  PokeWord(PROPGFX_SPRITECOUNT,0)
  R_W_EEPROM(0,PROPGFX_PARALLAX_TV_CODE,PROPGFX_TVCOGPTR,2)
  R_W_EEPROM(0,PROPGFX_STOP_COG_DEAD_CODE,PROPGFX_TILECOGPTR,2)
  R_W_EEPROM(0,PROPGFX_STOP_COG_CODE,PROPGFX_3DCOGPTR,2)
  ResetLite(0)
  FillWords($1800,PROPGFX_PARALLAX_SPACETILE,$800/2)

PUB Set16ColourSprites
  PokeByte(PROPGFX_SPRITECTRL,$80)

PUB Set4ColourSprites
  PokeByte(PROPGFX_SPRITECTRL,0)

PUB SetSpriteBase(addr)
  PokeWord(PROPGFX_SPRCHRPTR,addr)

PUB SetBorderColour(colour)
  PokeByte(PROPGFX_BORDERCOL,colour)

PUB SetPALNTSC(mode) | x
  PokeByte(PROPGFX_TVMODE,mode)
  R_W_EEPROM(1,PROPGFX_TVMODE,PROPGFX_TVMODE,1)
  x:=PeekByte(PROPGFX_XTILES)
  if x>32
    x:=8+((mode&1)<<1)
  else
    x:=10+((mode&1)<<1)
  PokeByte(PROPGFX_SCALEX,x)
  R_W_EEPROM(1,PROPGFX_SCALEX,PROPGFX_SCALEX,1)
  R_W_EEPROM(1,PROPGFX_XTILES,PROPGFX_XTILES,1)
  R_W_EEPROM(1,PROPGFX_YTILES,PROPGFX_YTILES,1)

PUB SetSprite(num,x,y,pal,chr) | s
  s:=PROPGFX_SPRITE_LIST_BASE+(num<<3)
  PokeWord(s,x)
  PokeWord(s+2,y)
  PokeWord(s+4,pal)
  PokeWord(s+6,chr)
PUB SendSpriteBuf(buf,numsprs)
  SendBuf(buf,PROPGFX_SPRITE_LIST_BASE,numsprs<<2)

PUB SetTV
  R_W_EEPROM(0,PROPGFX_MAIN_TV_CODE,PROPGFX_TVCOGPTR,2)
  ResetLite(0)

pub hex(val)
  prt(hextab[(val>>12)&15])
  prt(hextab[(val>>8)&15])
  prt(hextab[(val>>4)&15])
  prt(hextab[(val>>0)&15])

pub print(str)
  repeat while (byte[str])
    prt(byte[str++])

PUB prt(c)

  if c == 13
     newline
     c:=0
  PokeWord($1800+txty<<6+txtx++<<1,c)
  if txtx>31
    newline

pub newline
  txtx:=-1
  txty++
  if txty>23
    MoveWords($1840,$1800,23*32)
    FillWords($1800+23*64,0,32)
    txty:=23

pub setxy(x,y)
  txtx:=x
  txty:=y

pub backspace
    txtx--
    prt(32)
    txtx--
   
dat
hextab byte "0123456789ABCDEF"

DAT

fontpal       word      $0602   ' some spectrum style colours
              word      $060b
              word      $06bb
              word      $06db
              word      $065b
              word      $063c
              word      $068c
              word      $0006
'bright
              word      $0702
              word      $078f
              word      $073f
              word      $07bc
              word      $07df
              word      $073d
              word      $078e
              word      $0207

dat

        org 0                   ' org at 0 for start of cog                
SendBytes                       ' SendBytes asm code
        mov   myr0,PAR          ' myr0 is a temp var, set it to whatever PAR is ( pointer to sendsrc in Hub-RAM )
        rdlong mysrc,myr0       ' set mysrc to contents of sendsrc
        add   myr0,#4           ' point myr0 to senddst
        rdlong mydst,myr0       ' set mydst to contents of senddst
        add   myr0,#4           ' point myr0 to sendlen
        rdlong mylen,myr0 wz    ' set mylen to contents of sendlen and test if it's zero
  if_z  jmp   #SendBytes        ' if it's zero, means there's nothing to send just yet, so re-get vars and test again.
  
        mov   DIRA,mydira       ' set port pin directions
        mov   OUTA,#0           ' reset output pins

        mov   mybyteout,mylen
        shr   mybyteout,#16
        cmp   mybyteout,#PROPGFX_CMD_MAX wc,wz
  if_ae jmp   #SendBytes
        add   mybyteout,#:jmptable
        jmp   mybyteout           
:jmptable
        jmp   #:cmd_up
        jmp   #:cmd_vs
        jmp   #:cmd_db
        jmp   #:cmd_io
        jmp   #:cmd_cg
        jmp   #:cmd_id
        jmp   #:cmd_er
        jmp   #:cmd_ew
        jmp   #:cmd_dn
        jmp   #:cmd_rs
        jmp   #:cmd_pl
        jmp   #:cmd_fw
        jmp   #:cmd_mw
        
:cmd_up
        mov   mywordout,CMD_UP  ' get "JBUP"
        call  #send_long        ' send it
        mov   mywordout,mydst   ' get senddst
        call  #send_word        ' send it
        mov   mywordout,mylen   ' get sendlen
        call  #send_word        ' send it
:lp     rdbyte mybyteout,mysrc  ' get byte from Hub-RAM pointed to by sendsrc ( mysrc in cog ) 
        call  #send_byte        ' send it
        add   mysrc,#1          ' point mysrc to next byte 
        djnz  mylen,#:lp        ' decrease mylen and loop back to :lp until mylen=0 
:doneit wrlong myzero,myr0      ' clear sendlen, to say to other cogs it's all sent, and to stop this cog resending 
        jmp   #SendBytes        ' jump back to start, to wait for new command
        
:cmd_vs
        mov   mywordout,CMD_VS  ' get "JBVS"
        call  #send_long        ' send it
        jmp   #:doneit          ' jump to clear sendlen, to say it's clear, then back to wait for new command

:cmd_db
        mov   mywordout,CMD_DB  ' get "JBDB"
        call  #send_long        ' send it
        mov   mybyteout,mylen   ' get low byte of sendlen to set whether to turn LED ON or OFF
        call  #send_byte        ' send it
        jmp   #:doneit          ' jump to clear sendlen, to say it's clear, then back to wait for new command

:cmd_io
        mov   mywordout,CMD_IO  ' get "JBIO"
        call  #send_long        ' send it
        mov   mybyteout,mylen   ' get low byte of sendlen to set whether to set Serial Comms Mode or DataBus Mode
        call  #send_byte        ' send it
        jmp   #:doneit          ' jump to clear sendlen, to say it's clear, then back to wait for new command

:cmd_cg
        mov   mywordout,CMD_CG  ' get "JBCG"
        call  #send_long        ' send it
        mov   mywordout,mysrc   ' get sendsrc
        call  #send_long        ' send it
        jmp   #:doneit          ' jump to clear sendlen, to say it's clear, then back to wait for new command

:cmd_id
        mov   mywordout,CMD_ID  ' get "JBID"
        call  #send_long        ' send it
        add   myr0,#4           ' point myr0 to databack
        call  #get_byte         ' get it
        wrbyte mybyteout,myr0
        add   myr0,#1          
        call  #get_byte         ' get it
        wrbyte mybyteout,myr0
        add   myr0,#1          
        call  #get_byte         ' get it
        wrbyte mybyteout,myr0
        add   myr0,#1          
        call  #get_byte         ' get it
        wrbyte mybyteout,myr0   ' write it out to hub ram
        sub   myr0,#4+3         ' point myr0 back to sendlen
        jmp   #:doneit          ' jump to clear sendlen, to say it's clear, then back to wait for new command

:cmd_er
        mov   mywordout,CMD_ER  ' get "JBER"
        call  #send_long        ' send it
:send_sdl
        mov   mywordout,mysrc   ' get sendsrc
        call  #send_word        ' send it
        mov   mywordout,mydst   ' get senddst
        call  #send_word        ' send it
        mov   mywordout,mylen   ' get sendlen
        call  #send_word        ' send it
        jmp   #:doneit          ' jump to clear sendlen, to say it's clear, then back to wait for new command

:cmd_ew
        mov   mywordout,CMD_EW  ' get "JBEW"
        call  #send_long        ' send it
        jmp   #:send_sdl

:cmd_dn
        mov   mywordout,CMD_DN  ' get "JBDN"
        call  #send_long        ' send it
        mov   mywordout,mysrc   ' get sendsrc
        call  #send_word        ' send it
        mov   mywordout,mylen   ' get sendlen
        call  #send_word        ' send it
        and   mylen,myffff
:dnlp   call  #get_byte
        wrbyte mybyteout,mydst  ' get byte from Lite Hub-RAM pointed to by sendsrc ( mysrc in cog ) 
        add   mydst,#1          ' point mysrc to next byte 
        djnz  mylen,#:dnlp        ' decrease mylen and loop back to :lp until mylen=0 
        jmp   #:doneit          ' jump to clear sendlen, to say it's clear, then back to wait for new command

:cmd_rs
        mov   mywordout,CMD_RS  ' get "JBRS"
        call  #send_long        ' send it
        mov   mybyteout,mylen   ' get soft/hard reset switch
        call  #send_byte        ' send it
        jmp   #:doneit          ' jump to clear sendlen, to say it's clear, then back to wait for new command

:cmd_pl
        mov   mywordout,CMD_PL  ' get "JBPL"
        call  #send_long        ' send it
        jmp   #:doneit          ' jump to clear sendlen, to say it's clear, then back to wait for new command

:cmd_fw
        mov   mywordout,CMD_FW  ' get "JBFW"
        call  #send_long        ' send it
        jmp   #:send_sdl

:cmd_mw
        mov   mywordout,CMD_MW  ' get "JBMW"
        call  #send_long        ' send it
        jmp   #:send_sdl

        jmp   #:doneit

sendhex
        mov   mywordout,CMD_UP
        call  #send_long
        mov   mywordout,myr4
        call  #send_word
        mov   mywordout,#8*2
        call  #send_word
        mov   myr3,#8
:lp     rol   mysrc,#4
        mov   mybyteout,mysrc
        and   mybyteout,#15
        add   mybyteout,#"0"
        cmp   mybyteout,#"9" wc,wz
  if_a  add   mybyteout,#7
        call  #send_word
        djnz  myr3,#:lp 
sendhex_ret ret
         
interpreter long ($0004 << 16) | ($F004 << 2) | %0000

send_long
        call  #send_word
        shr   mywordout,#16
        call  #send_word
send_long_ret
        ret        

send_word
        mov   mybyteout,mywordout
        call  #send_byte
        mov   mybyteout,mywordout
        shr   mybyteout,#8
        call  #send_byte
send_word_ret
        ret

send_byte        
        or    DIRA,mydatadir
        waitpne   mypinok,mypinok ' wait for pinok to be clear
        and   mybyteout,#255    ' mask out the byte to send
        shl   mybyteout,#MYDATASHIFT '#16 shift it left, to align to pins
        or    mybyteout,myclk   ' or in myclk to set myclk hi to tell lite data is there
        mov   OUTA,mybyteout    ' send it to the output port
        waitpeq   mypinok,mypinok ' wait for pinok to be set
        mov  OUTA,#0 'myclk        ' clear clk + data
send_byte_ret
        ret                     ' return

get_byte        
        andn  DIRA,mydatadir
        or    OUTA,myclk        ' in myclk to set myclk hi to tell lite data is there
        waitpeq   mypinok,mypinok ' wait for pinok to be set
        mov   mybyteout,INA
        shr   mybyteout,#MYDATASHIFT '#16 shift it left, to align to pins
        and   mybyteout,#255    ' mask out the byte to send
        andn  OUTA,myclk        ' clear clk
        waitpne   mypinok,mypinok ' wait for pinok to be clear
get_byte_ret
        ret                     ' return

CMD_UP  byte  "J","B","U","P"
CMD_VS  byte  "J","B","V","S"
CMD_DB  byte  "J","B","D","B"
CMD_IO  byte  "J","B","I","O"
CMD_CG  byte  "J","B","G","C"
CMD_ID  byte  "J","B","I","D"
CMD_ER  byte  "J","B","E","R"
CMD_EW  byte  "J","B","E","W"
CMD_DN  byte  "J","B","D","N"
CMD_RS  byte  "J","B","R","S"
CMD_PL  byte  "J","B","P","L"
CMD_FW  byte  "J","B","F","W"
CMD_MW  byte  "J","B","M","W"
CMD_CM  byte  "J","B","C","M"
CMD_BT  byte  "J","B","B","T"

fff9ffff long $fff9ffff
        
myclk   long  MYCLKVAL          ' myclk value to or into data sent to port pins
mydira  long  MYDIRAVAL         ' mydira to set IO pins direction for comms
mydatadir  long  MYDATADIRVAL   ' mydatadir to set IO data pins direction for comms
mypinok long  MYPINOKVAL        ' mypinok value to test input to see if Lite is ready to recieve data.

myzero  long  0                 ' zero, used for clearing sendlen, incase i wanted to change it to -1 for idle, but didn't :)
myffff  long  $ffff

x1800   long  $1800

mybyteout res 1
mywordout res 1
mycog   res   1
mysrc   res   1
mydst   res   1
mylen   res   1
myr0    res   1
myr1    res   1
myr2    res   1
myr3    res   1
myr4    res   1
mycogid res   1